"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultProps = exports.stateFunctions = exports.stateAssignments = exports.useStoreVariableDeclarator = exports.useStateVariableDeclarator = exports.validateStateVariableDeclarator = void 0;
const generator_1 = __importDefault(require("@babel/generator"));
const t = __importStar(require("@babel/types"));
const utils_1 = require("../utils");
const utils_2 = require("../../utils");
const validateStateVariableDeclarator = (path, scope) => {
    if (path.node.init &&
        path.node.init.type === 'CallExpression' &&
        path.node.init.callee &&
        path.node.init.callee.type === 'Identifier' &&
        path.node.init.callee.name === 'useState') {
        const node = path.node;
        if (node.id.type !== 'ArrayPattern') {
            return (0, utils_2.throwError)('useState must use an array');
        }
        if (node.id.elements.length !== 2) {
            return (0, utils_2.throwError)('useState must use an array of length 2');
        }
        if (node.id.elements[0].type !== 'Identifier') {
            return (0, utils_2.throwError)('useState first element must be Identifier');
        }
        if (node.id.elements[1].type !== 'Identifier') {
            return (0, utils_2.throwError)('useState second element must be Identifier');
        }
        const current = scope.currentComponent();
        if (!current) {
            console.log((0, generator_1.default)(node).code);
            (0, utils_2.throwError)('cursor missing');
        }
        // store in hash
        const name = node.id.elements[0].name;
        if (!scope.currentComponent()?.state?.exists(name)) {
        }
        else {
            scope.currentComponent().addProp({
                name,
                derived: 'useState',
                from: 'ObjectProperty',
            });
        }
    }
};
exports.validateStateVariableDeclarator = validateStateVariableDeclarator;
const useStateVariableDeclarator = (path, scope) => {
    (0, exports.validateStateVariableDeclarator)(path, scope);
    if (path.node.init &&
        path.node.init.type === 'CallExpression' &&
        path.node.init.callee &&
        path.node.init.callee.type === 'Identifier' &&
        path.node.init.callee.name === 'useState') {
        // process node
        if (path.node.init.arguments[0].type === 'ArrowFunctionExpression') {
            return;
        }
        // update arguments
        path.node.init.arguments = [
            t.arrowFunctionExpression([], path.node.init.arguments[0], false)
        ];
    }
};
exports.useStateVariableDeclarator = useStateVariableDeclarator;
const useStoreVariableDeclarator = (path, scope) => {
    if (path.node.init &&
        path.node.init.type === 'CallExpression' &&
        path.node.init.callee &&
        path.node.init.callee.type === 'Identifier' &&
        path.node.init.callee.name === 'useStore') {
        const args = path.node.init.arguments;
        const objectArgument = args[0];
        if (t.isObjectExpression(objectArgument) && objectArgument.properties.length > 0) {
            const newDeclarations = objectArgument.properties.map(property => {
                switch (property.type) {
                    case 'ObjectMethod': {
                        const method = property;
                        const key = method.key;
                        if (key.type !== 'Identifier') {
                            (0, utils_2.throwError)('store methods must be Identifiers');
                        }
                        if (scope.currentComponent().findProp(key.name)) {
                            (0, utils_2.throwError)('state variable is already defined!');
                        }
                        scope.currentComponent().addProp({
                            name: key.name,
                            derived: 'useStore',
                            from: 'ObjectMethod'
                        });
                        return t.functionDeclaration(t.identifier(key.name), method.params, method.body, method.generator, method.async);
                    }
                    case 'ObjectProperty': {
                        const prop = property;
                        const key = prop.key;
                        if (key.type !== 'Identifier') {
                            (0, utils_2.throwError)('store object properties must be Identifier');
                        }
                        if (!scope.currentComponent()?.findProp(key.name)) {
                            // throwError('state variable is already defined!');
                        }
                        scope.currentComponent().addProp({
                            name: key.name,
                            derived: 'useStore',
                            from: 'ObjectProperty'
                        });
                        const stateName = t.identifier(key.name);
                        const stateSetterName = t.identifier((0, utils_1.makeSetState)(key.name));
                        return t.variableDeclaration('const', [
                            t.variableDeclarator(t.arrayPattern([stateName, stateSetterName]), t.callExpression(t.identifier('useState'), [t.arrowFunctionExpression([], prop.value)]))
                        ]);
                    }
                    default:
                        (0, utils_2.throwError)('store must be ObjectMethod or ObjectProperty');
                }
                // @ts-ignore
                const prop = property;
                const key = prop.key;
                if (key.type !== 'Identifier') {
                    (0, utils_2.throwError)('store object properties must be Identifier');
                }
                const stateName = t.identifier(key.name);
                const stateSetterName = t.identifier((0, utils_1.makeSetState)(key.name));
                return t.variableDeclaration('const', [
                    t.variableDeclarator(t.arrayPattern([stateName, stateSetterName]), t.callExpression(t.identifier('useState'), [t.arrowFunctionExpression([], prop.value)]))
                ]);
            });
            // this updates the array above! awesome!
            path.parentPath.replaceWithMultiple(newDeclarations);
        }
    }
};
exports.useStoreVariableDeclarator = useStoreVariableDeclarator;
const stateAssignments = (path, scope) => {
    // STATE
    // FROM state.property = value;
    // TO   setProperty(value);
    if (path.node.type === 'AssignmentExpression') {
        if (path.node.left.type === 'MemberExpression') {
            if (path.node.left.object.type === 'Identifier') {
                if (path.node.left.object.name === 'state') {
                    // left: path.node.left.property as any
                    if (path.node.left.property.type !== 'Identifier') {
                        return (0, utils_2.throwError)('set state property not yet supported.');
                    }
                    // set that state variable is used!
                    const name = path.node.left.property.name;
                    const current = scope.currentComponent(true);
                    if (current.findProp(name)) {
                        current.findProp(name).setUsed(true);
                    }
                    else {
                        (0, utils_2.throwError)(scope.errorMsg('PROP_SET_NOT_FOUND', { prop: name }));
                    }
                    path.replaceWith(t.expressionStatement(t.callExpression(t.identifier((0, utils_1.makeSetState)(path.node.left.property.name)), [path.node.right])));
                }
            }
        }
    }
};
exports.stateAssignments = stateAssignments;
const stateFunctions = (path, scope) => {
    // STATE
    // FROM state.method(value)
    // TO   method(value);
    if (path.node.type === 'CallExpression') {
        if (path.node.callee.type === 'MemberExpression') {
            if (path.node.callee.object.type === 'Identifier') {
                if (path.node.callee.object.name === 'state') {
                    // left: path.node.callee.property as any
                    if (path.node.callee.property.type !== 'Identifier') {
                        return (0, utils_2.throwError)('set state property not yet supported.');
                    }
                    // set that state variable is used!
                    const name = path.node.callee.property.name;
                    const current = scope.currentComponent();
                    if (!current) {
                        (0, utils_2.throwError)(scope.errorMsg('PROP_FUNC_COMP_NOT_FOUND', { prop: name }));
                    }
                    if (current.state.exists(name)) {
                        current.state.get(name).setUsed(true);
                    }
                    else {
                        (0, utils_2.throwError)(scope.errorMsg('PROP_FUNC_NOT_FOUND', { prop: name }));
                    }
                    path.replaceWith(t.callExpression(path.node.callee.property, path.node.arguments));
                }
            }
        }
    }
};
exports.stateFunctions = stateFunctions;
const defaultProps = (path, scope) => {
    if (path.node.callee.type === 'Identifier' &&
        path.node.callee.name === 'useDefaultProps') {
        const args = path.node.arguments;
        const Component = args[0];
        const Props = args[1];
        if (Component.type !== 'Identifier') {
            (0, utils_2.throwError)('useDefaultProps first argument must be an Identifier');
        }
        if (Props.type !== 'ObjectExpression') {
            (0, utils_2.throwError)('useDefaultProps first argument must be an ObjectExpression');
        }
        // replace with Component.defaultProps = Props;
        path.replaceWith(t.expressionStatement(t.assignmentExpression('=', t.memberExpression(t.identifier(Component.name), t.identifier('defaultProps'), false), Props)));
    }
};
exports.defaultProps = defaultProps;
