"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseTertiary = void 0;
const t = __importStar(require("@babel/types"));
const traverse_1 = __importDefault(require("@babel/traverse"));
const utils_1 = require("../../utils");
const parseTertiary = (path, scope) => {
    if (path.node.openingElement.type !== 'JSXOpeningElement')
        return;
    if (path.node.openingElement.name.type !== 'JSXIdentifier')
        return;
    if (path.node.openingElement.name.name !== 'Show')
        return;
    if (path.node.openingElement.attributes.length !== 2) {
        (0, utils_1.throwError)('Show requires 2 arguments: when, fallback');
    }
    if (path.node.openingElement.attributes[0].type !== 'JSXAttribute')
        return;
    if (path.node.openingElement.attributes[1].type !== 'JSXAttribute')
        return;
    const when = path.node.openingElement.attributes[0];
    if (when.name.type !== 'JSXIdentifier')
        return;
    if (when.name.name !== 'when') {
        (0, utils_1.throwError)('Show requires when prop!');
    }
    const whenExprContainer = when.value;
    const fallback = path.node.openingElement.attributes[1];
    if (fallback.name.type !== 'JSXIdentifier')
        return;
    if (fallback.name.name !== 'fallback') {
        (0, utils_1.throwError)('Show requires fallback prop!');
    }
    const fallbackExprContainer = fallback.value;
    const jsxEl = path.node.children.find(el => el.type === 'JSXElement');
    // RECURSION
    // base recursion case
    if (!jsxEl)
        return;
    const finalExpr = t.conditionalExpression(whenExprContainer.expression, jsxEl, fallbackExprContainer.expression);
    return path.replaceWith(t.jsxExpressionContainer(finalExpr));
    // path.replaceWith(t.jsxExpressionContainer(finalExpr));
    // return true;
    // RECURSION
    // RECURSION
    // RECURSION
    const programNode = t.file(t.program([
        t.functionDeclaration(t.identifier('fakeFunction'), [], t.blockStatement([
            t.returnStatement(
            // RECURSION
            // JSX goes here
            finalExpr)
        ]))
    ]));
    // bake
    (0, traverse_1.default)(programNode, {
        JSXElement(returnPath) {
            (0, exports.parseTertiary)(returnPath, scope);
        }
    });
    // pull out of the oven
    const funcDecl = programNode.program.body[0];
    const blockStm = funcDecl.body;
    const retnStmt = blockStm.body[0];
    const output = t.jsxExpressionContainer(retnStmt.argument);
    path.replaceWith(output);
};
exports.parseTertiary = parseTertiary;
