import * as t from '@babel/types';
import traverse from '@babel/traverse';
import { throwError } from '../../utils';
export const parseTertiary = (path, scope) => {
    if (path.node.openingElement.type !== 'JSXOpeningElement')
        return;
    if (path.node.openingElement.name.type !== 'JSXIdentifier')
        return;
    if (path.node.openingElement.name.name !== 'Show')
        return;
    if (path.node.openingElement.attributes.length !== 2) {
        throwError('Show requires 2 arguments: when, fallback');
    }
    if (path.node.openingElement.attributes[0].type !== 'JSXAttribute')
        return;
    if (path.node.openingElement.attributes[1].type !== 'JSXAttribute')
        return;
    const when = path.node.openingElement.attributes[0];
    if (when.name.type !== 'JSXIdentifier')
        return;
    if (when.name.name !== 'when') {
        throwError('Show requires when prop!');
    }
    const whenExprContainer = when.value;
    const fallback = path.node.openingElement.attributes[1];
    if (fallback.name.type !== 'JSXIdentifier')
        return;
    if (fallback.name.name !== 'fallback') {
        throwError('Show requires fallback prop!');
    }
    const fallbackExprContainer = fallback.value;
    const jsxEl = path.node.children.find(el => el.type === 'JSXElement');
    // RECURSION
    // base recursion case
    if (!jsxEl)
        return;
    const finalExpr = t.conditionalExpression(whenExprContainer.expression, jsxEl, fallbackExprContainer.expression);
    return path.replaceWith(t.jsxExpressionContainer(finalExpr));
    // path.replaceWith(t.jsxExpressionContainer(finalExpr));
    // return true;
    // RECURSION
    // RECURSION
    // RECURSION
    const programNode = t.file(t.program([
        t.functionDeclaration(t.identifier('fakeFunction'), [], t.blockStatement([
            t.returnStatement(
            // RECURSION
            // JSX goes here
            finalExpr)
        ]))
    ]));
    // bake
    traverse(programNode, {
        JSXElement(returnPath) {
            parseTertiary(returnPath, scope);
        }
    });
    // pull out of the oven
    const funcDecl = programNode.program.body[0];
    const blockStm = funcDecl.body;
    const retnStmt = blockStm.body[0];
    const output = t.jsxExpressionContainer(retnStmt.argument);
    path.replaceWith(output);
};
